//
//  TDWindowController.m
//  ToDo
//
//  Created by narita on 2013/10/16.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "TDWindowController.h"

@interface TDWindowController ()

@end

@implementation TDWindowController

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    
    if( self )
    {
        // Initialization code here.
    }
    
    return self;
}

#pragma mark -
#pragma mark dealloc

- (void)dealloc
{
    self.selectedIndex    = nil;
    self.sortDescriptorArray = nil;
}

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

+ (NSArray *)restorableStateKeyPaths
{
    // 何故かNSArrayControllerに対するselectedIndexsが保存復帰出来ない
    return [[super restorableStateKeyPaths] arrayByAddingObjectsFromArray:@[ @"selectedIndex", @"sortDescriptorArray" ]];
}

#pragma mark -
#pragma mark awakeFromNib-like methods

- (void)windowDidLoad
{
    [super windowDidLoad];
    
    // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
}

#pragma mark -
#pragma mark action & canAction methods

#pragma mark -
#pragma mark delegate/datasource methods

- (NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)window
{
    return [[[self document] managedObjectContext] undoManager];
}

#pragma mark -
#pragma mark accessor methods (in pairs)

// クラス名と同じnibファイルを読み込む

- (NSString *)windowNibName
{
    NSString* theSuperWindowNibName = [super windowNibName];
    
    if(theSuperWindowNibName != nil && ![theSuperWindowNibName isEqualToString:@""])
    {
        return theSuperWindowNibName;
    }
    else
    {
        NSString* theClassName = NSStringFromClass([self class]);
        
        return theClassName;
    }
}

- (void) setSelectedIndex:(NSIndexSet *)selectedIndex
{
    _selectedIndex = selectedIndex;
    [self invalidateRestorableState];
}

- (void) setSortDescriptorArray:(NSArray *)sortDescriptorArray
{
    _sortDescriptorArray = sortDescriptorArray;
    [self invalidateRestorableState];
}

#pragma mark -
#pragma mark Utility methods

- (NSString *) windowTitleForDocumentDisplayName: (NSString *)displayName
{
    if ([self document] != nil)
    {
		NSString*	theDisplayName;
		NSArray*	theWinCtrls;
		
		theDisplayName = [[self document] displayName];
		theWinCtrls = [[self document] windowControllers];
		
		if([theWinCtrls count] > 1)
		{
			NSUInteger	theIndex;
			NSString*	theResult;
			
			//	NSArrayのindexが０から始まるため+1する
			theIndex = [theWinCtrls indexOfObject:self] + 1;
			
			theResult = [NSString stringWithFormat:@"%@:(%lu)", theDisplayName, theIndex];
			
			return theResult;
		}
		else
		{
			return [super windowTitleForDocumentDisplayName:displayName];
		}
    }
    else
    {
		return [super windowTitleForDocumentDisplayName:displayName];
    }
}

@end
